CREATE OR REPLACE FUNCTION get_top_tag_groups()
RETURNS JSON AS $$
BEGIN
  RETURN json_build_object(
    'tags', (
      SELECT json_agg(t) FROM (
        SELECT tag, COUNT(*) AS usage_count
        FROM optimized_tagged_content
        WHERE type IN ('article', 'link')
        GROUP BY tag
        ORDER BY usage_count DESC
        LIMIT 10
      ) t
    ),
    'watching_genres', (
      SELECT json_agg(t) FROM (
        SELECT tag, COUNT(*) AS usage_count
        FROM optimized_tagged_content
        WHERE type IN ('tv', 'movies')
        GROUP BY tag
        ORDER BY usage_count DESC
        LIMIT 10
      ) t
    ),
    'books_genres', (
      SELECT json_agg(t) FROM (
        SELECT tag, COUNT(*) AS usage_count
        FROM optimized_tagged_content
        WHERE type = 'books'
        GROUP BY tag
        ORDER BY usage_count DESC
        LIMIT 10
      ) t
    )
  );
END;
$$ LANGUAGE plpgsql STABLE;
